c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine celij(j1,j2,kind,kind_p1,ini_kind_p2,ly2)
c
      include 'common.3D'  
	 
	do kind_p2=ini_kind_p2,2
        if(nc(j2,kind_p2).ne.0) then

        is1 = ist(j1,kind_p1)
        ie1 = ien(j1,kind_p1)
	
        do ii=is1,ie1
         i = ip(ii,kind_p1)
         is2 = ist(j2,kind_p2)
         ie2 = ien(j2,kind_p2)

         do jj=is2,ie2
            j = ip(jj,kind_p2)
            drx = xp(i) - xp(j)
            dry = yp(i) - yp(j)
            drz = zp(i) - zp(j)
            rr2 = drx*drx + dry*dry + drz*drz

            if(ly2.gt.ncy)then
              if(dry.gt.four_h)then  !if(dry.gt.4.0*h)then
                dyp_dble1 = ymax_container_double-dble(yp(i))
                dyp_dble2 = dble(yp(j))-ymin_container_double
                dry = -real(dyp_dble1+dyp_dble2)
              end if
            end if

	     if(rr2.le.fourh2(kind).and.rr2.ge.1.e-18) then
             dux = up(i) - up(j)
             duy = vp(i) - vp(j)
             duz = wp(i) - wp(j)

c             Calculating kernel & Normalized Kernel

	       call kernel(drx,dry,drz,i,j,j1,j2,kind,rr2)   
  
             
c  ...  average density

            robar  = 0.5*( rhop(i) + rhop(j) )
            one_over_rhobar = 2.0/(rhop(i) + rhop(j))
c
		  cbar = 0.5*( cs(i)   + cs(j)   ) 

c  ...  inner product rv
c
            dot = drx*dux + dry*duy + drz*duz

c	  Used to calculate the time step due to viscosity

            visc_dt=max(dot/(rr2 + eta2),visc_dt) 
c
c  ...  pressure and viscous force (Monaghan 1992; Ann. Rev.
c			        Astron. Astrop. 30. Formula 3.3)
c         pm(j) is mass of particle j
c
            p_v = pr(i) + pr(j) !+ pi_visc


c  	Tensile correction (Monaghan , JCP.  159 (2000) 290- 311)
c	Only to be activated with cubic spline kernel 
	
		  if (index_tensile.eq.1) then

c   ____ Tensile correction
 
             fab=Wab*od_Wdeltap(kind) !NOTE: We'll use a non-normalized
             fab=fab*fab				!kernel to calculate tensile correction
             fab=fab*fab   !  It's the (Wab/Wdeltap)**4  of Monaghan's paper

             if (p(i).gt.0) then
                  Ra= 0.01 *pr(i)
             else
                  Ra= 0.2 *abs(pr(i))
             endif

             if (p(j).gt.0) then
                  Rb= 0.01 *pr(j)
             else
                  Rb= 0.2 *abs(pr(j))
             endif

             R=Ra+Rb
             p_v = p_v+ R*fab


		 endif

           ax(i) = ax(i) - pm(j) * p_v * frx
           ay(i) = ay(i) - pm(j) * p_v * fry
           az(i) = az(i) - pm(j) * p_v * frz

           ax(j) = ax(j) + pm(i) * p_v * frx
           ay(j) = ay(j) + pm(i) * p_v * fry
           az(j) = az(j) + pm(i) * p_v * frz


c            --- CSPH terms ---

             Vj = pm(j)/rhop(j)    !Vj = pVol(j)   !

             frx_norm_i = Vj*frx   !/sum_dWdx(i)
             fry_norm_i = Vj*fry   !/sum_dWdy(i)
             frz_norm_i = Vj*frz   !/sum_dWdz(i)


             dudx_CSPH(i) = dudx_CSPH(i) - dux*frx_norm_i
             dudy_CSPH(i) = dudy_CSPH(i) - dux*fry_norm_i
             dudz_CSPH(i) = dudz_CSPH(i) - dux*frz_norm_i
             dvdx_CSPH(i) = dvdx_CSPH(i) - duy*frx_norm_i
             dvdy_CSPH(i) = dvdy_CSPH(i) - duy*fry_norm_i
             dvdz_CSPH(i) = dvdz_CSPH(i) - duy*frz_norm_i
             dwdx_CSPH(i) = dwdx_CSPH(i) - duz*frx_norm_i
             dwdy_CSPH(i) = dwdy_CSPH(i) - duz*fry_norm_i
             dwdz_CSPH(i) = dwdz_CSPH(i) - duz*frz_norm_i
 
             Vi = pm(i)/rhop(i)    !Vi = pVol(i)   !

             frx_norm_j = Vi*frx   !/sum_dWdx(j)
             fry_norm_j = Vi*fry   !/sum_dWdy(j)
             frz_norm_j = Vi*frz   !/sum_dWdz(j)


             dudx_CSPH(j) = dudx_CSPH(j) - dux*frx_norm_j
             dudy_CSPH(j) = dudy_CSPH(j) - dux*fry_norm_j
             dudz_CSPH(j) = dudz_CSPH(j) - dux*frz_norm_j
             dvdx_CSPH(j) = dvdx_CSPH(j) - duy*frx_norm_j
             dvdy_CSPH(j) = dvdy_CSPH(j) - duy*fry_norm_j
             dvdz_CSPH(j) = dvdz_CSPH(j) - duy*frz_norm_j
             dwdx_CSPH(j) = dwdx_CSPH(j) - duz*frx_norm_j
             dwdy_CSPH(j) = dwdy_CSPH(j) - duz*fry_norm_j
             dwdz_CSPH(j) = dwdz_CSPH(j) - duz*frz_norm_j

	     call viscosity(dot,drx,dry,drz,dux,duy,duz,kind,rr2,
     +                  cbar,robar,one_over_rhobar,i,j,j1,j2,term2)


c   ...         Thermal Energy
c		(Monaghan, JCP 110 (1994) 399- 406)


           term1=0.5 * p_v *( frx*dux+fry*duy+frz*duz)

           aTE(i)=aTE(i)+pm(j) * (term1+term2)
           aTE(j)=aTE(j)+pm(i) * (term1+term2)


c  ...  density acceleration (Monaghan 1992; Ann. Rev. Astron. Astrop. 30. Formula 3.9)
c       using the derivative of the kernel, not the kernel itself

           dot2 = dux*frx + duy*fry + duz*frz
           ar(i) = ar(i) + pm(j)*dot2

           ar(j) = ar(j) + pm(i)*dot2

c
c  ...  XSPH correction (Monaghan 1994;  J. Comp. Phys. 110. Formula 2.6)
c
             pmj_Wab_over_rhobar = pm(j)*Wab*one_over_rhobar
             ux(i) = ux(i) - dux*pmj_Wab_over_rhobar  !pm(j) * dux * Wab / robar ! (2.6)
             vx(i) = vx(i) - duy*pmj_Wab_over_rhobar  !pm(j) * duy * Wab / robar ! (2.6)
             wx(i) = wx(i) - duz*pmj_Wab_over_rhobar  !pm(j) * duz * Wab / robar

             pmi_Wab_over_rhobar = pm(j)*Wab*one_over_rhobar
             ux(j) = ux(j) + dux*pmi_Wab_over_rhobar   !pm(i) * dux * Wab / robar
             vx(j) = vx(j) + duy*pmi_Wab_over_rhobar   !pm(i) * duy * Wab / robar
             wx(j) = wx(j) + duz*pmi_Wab_over_rhobar   !pm(i) * duz * Wab / robar



c  ...  Vorticity calculation

               if(ivort_calc.eq.1.and.i.gt.nb.and.j.gt.nb)then
			   if(sum_dWdx(i).gt.0.0001 .and. sum_dWdz(i).gt.0.0001) then
c                 curl3xi = duy*frz/sum_dWdz(i)
c     &                 - duz*fry/sum_dWdy(i)
c                 curl3yi = duz*frx/sum_dWdx(i)
c     &                 - dux*frz/sum_dWdz(i)
c                 curl3zi = dux*fry/sum_dWdy(i)
c     &                 - duy*frx/sum_dWdx(i)
c                 V_tempi = pm(j)/rhop(i)
c                 curl3xj = duy*frz/sum_dWdz(j)
c     &                 - duz*fry/sum_dWdy(j)
c                 curl3yj = duz*frx/sum_dWdx(j)
c     &                 - dux*frz/sum_dWdz(j)
c                 curl3zj = dux*fry/sum_dWdy(j)
c     &                 - duy*frx/sum_dWdx(j)
c                 V_tempj = pm(i)/rhop(j)
c                 vortx(i) = vortx(i) + V_tempi*curl3xi   !Vorticity in an x=const plane
c                 vorty(i) = vorty(i) + V_tempi*curl3yi   !Vorticity in an y=const plane
c                 vortz(i) = vortz(i) + V_tempi*curl3zi   !Vorticity in an z=const plane
c                 vortx(j) = vortx(j) + V_tempj*curl3xj   !Vorticity in an x=const plane
c                 vorty(j) = vorty(j) + V_tempj*curl3yj   !Vorticity in an y=const plane
c                 vortz(j) = vortz(j) + V_tempj*curl3zj   !Vorticity in an z=const plane


				curl3x_a(i)= curl3x_a(i)+duy*frz*pm(j)/rhop(i)
				curl3x_b(i)= curl3y_b(i)+duz*fry*pm(j)/rhop(i)
				curl3y_a(i)= curl3y_a(i)+duz*frx*pm(j)/rhop(i)
				curl3y_b(i)= curl3y_b(i)+dux*frz*pm(j)/rhop(i)
				curl3z_a(i)= curl3y_a(i)+duz*fry*pm(j)/rhop(i)
				curl3z_b(i)= curl3y_b(i)+duy*frx*pm(j)/rhop(i)

				curl3x_a(j)= curl3x_a(j)+duy*frz*pm(i)/rhop(j)
				curl3x_b(j)= curl3y_b(j)+duz*fry*pm(i)/rhop(j)
				curl3y_a(j)= curl3y_a(j)+duz*frx*pm(i)/rhop(j)
				curl3y_b(j)= curl3y_b(j)+dux*frz*pm(i)/rhop(j)
				curl3z_a(j)= curl3y_a(j)+duz*fry*pm(i)/rhop(j)
				curl3z_b(j)= curl3y_b(j)+duy*frx*pm(i)/rhop(j)

				endif
 	        endif    
		 endif
         enddo
        enddo
	 endif
	enddo

      end