c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine kernel(drx,dry,drz,i,j,j1,j2,kind,rr2)

      include 'common.3D'   

      index_tensile= 1

c     Cubic 3D Kernel

      rad = sqrt(rr2)
      qq  = rad/hh(kind)

      if(rr2.gt.h2(kind)) then               
         tmq = 2.-qq
         tm2 = tmq*tmq
         tm3 = tm2*tmq
         Wab = a24(kind)*tm3
 
         fac = c2(kind)*tm2 /rad
         frx = fac * drx
         fry = fac * dry
         frz = fac * drz
      else 
         q2  = qq*qq
         q3  = q2*qq

         Wab = a2(kind)*( 1. - 1.5*q2 + 0.75*q3 )

         fac = (c1(kind)*qq + d1(kind)*q2) /rad
         frx = fac * drx
         fry = fac * dry
         frz = fac * drz
		  
      endif

c      Sum_wab to calculate the normalized kernel
       if(j.gt.nstart_minus1)then
         V_j = pVol(j)  !=pm(j)/rhop(j)               
         sum_wab(i)  = sum_wab(i)  + Wab*V_j   !pm(j)/rhop(j)	
         rhop_sum(i) = rhop_sum(i) + pm(j)*Wab       
         !sum_dWdx(i) = sum_dWdx(i) - frx*drx*V_j
         !sum_dWdy(i) = sum_dWdy(i) - frx*dry*V_j
         !sum_dWdz(i) = sum_dWdz(i) - frz*drz*V_j
       end if
                                   
       if(j1.ne.j2.and.i.gt.nstart_minus1)then	! only for celij		  
         V_i = pVol(i)   !=pm(i)/rhop(i)
         sum_wab(j)  = sum_wab(j)  + Wab*V_i 
         rhop_sum(j) = rhop_sum(j) + pm(i)*Wab       
         !sum_dWdx(j) = sum_dWdx(j) - frx*drx*V_i
         !sum_dWdy(j) = sum_dWdy(j) - frx*dry*V_i
         !sum_dWdz(j) = sum_dWdz(j) - frz*drz*V_i
       endif

      return 
      end
