c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	subroutine variable_time_step
      include 'common.3D'

C	Calculate time step 
c	Conditions given in 
c		Monaghan (1989), JCP 82, 1-15
c	    Monaghan & Kos (1999), JWPCOE 125, 145-154

	Fa_max=-1000
	cs_max=-1000

	do i=nstart,np
	     Fa=sqrt(ax(i)*ax(i)+ay(i)*ay(i)+az(i)*az(i))
	     if (Fa.ge.Fa_max) then
             i_fa=i
	       Fa_max=Fa
	     endif
	     if (cs(i).ge.cs_max) then
		   cs_max=cs(i)
	     endif
	enddo 

	Fa_sqrt=((ax(i_fa)+grx)**2+(ay(i_fa)+gry)**2 +
     +         (az(i_fa)+grz)**2)**0.25
	dt_1=sqrt(h)/Fa_sqrt

      dt_2=h/(cs_max+h*visc_dt)
	dt_new=0.1*min(dt_1,dt_2)
      

	return

	end